Codeforces Round #307 (Div. 2)

A. GukiZ and Contest
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Professor GukiZ likes programming contests. He especially likes to rate his students on the contests he prepares. Now, he has decided to prepare a new contest.

In total, n students will attend, and before the start, every one of them has some positive integer rating. Students are indexed from 1 to n. Let's denote the rating of i-th student as ai. After the contest ends, every student will end up with some positive integer position. GukiZ expects that his students will take places according to their ratings.

He thinks that each student will take place equal to . In particular, if student A has rating strictly lower then student BA will get the strictly better position than B, and if two students have equal ratings, they will share the same position.

GukiZ would like you to reconstruct the results by following his expectations. Help him and determine the position after the end of the contest for each of his students if everything goes as expected.

Input

The first line contains integer n (1 ≤ n ≤ 2000), number of GukiZ's students.

The second line contains n numbers a1, a2, ... an (1 ≤ ai ≤ 2000) where ai is the rating of i-th student (1 ≤ i ≤ n).

Output

In a single line, print the position after the end of the contest for each of n students in the same order as they appear in the input.

Sample test(s)
input
3
1 3 3
output
3 1 1
input
1
1
output
1
input
5
3 5 3 4 5
output
4 1 4 3 1
Note

In the first sample, students 2 and 3 are positioned first (there is no other student with higher rating), and student 1 is positioned third since there are two students with higher rating.

In the second sample, first student is the only one on the contest.

In the third sample, students 2 and 5 share the first position with highest rating, student 4 is next with third position, and students 1 and 3are the last sharing fourth position.

求所有数在大小排好的顺序中的位置,直接暴力233

#include <bits/stdc++.h>
using namespace std;
#define Max 2333
int a[Max],b[Max],c[Max];
int n,t;

int main()
{
	cin>>n;
	for(int i=1;i<=n;i++)
	{
		cin>>t;
		a[i]=t;
	}
	int p=0;
	int maxx;
	while(p!=n)
	{
		maxx=0;
		int t=0;
		for(int i=1;i<=n;i++)
		{
			if(!b[i]&&maxx<a[i])
			{
				maxx=a[i];
			}
		}
		for(int i=1;i<=n;i++)
		{
			if(a[i]==maxx)
			{
				b[i]=1;
				t++;p++;
			}
		}
		c[maxx]=p-t+1;
	}
	for(int i=1;i<=n;i++)
	{
		cout<<c[a[i]]<<" ";
	}
	return 0;
}

B. ZgukistringZ
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Professor GukiZ doesn't accept string as they are. He likes to swap some letters in string to obtain a new one.

GukiZ has strings ab, and c. He wants to obtain string k by swapping some letters in a, so that k should contain as many non-overlapping substrings equal either to b or c as possible. Substring of string x is a string formed by consecutive segment of characters from x. Two substrings of string x overlap if there is position i in string x occupied by both of them.

GukiZ was disappointed because none of his students managed to solve the problem. Can you help them and find one of possible stringsk?

Input

The first line contains string a, the second line contains string b, and the third line contains string c (1 ≤ |a|, |b|, |c| ≤ 105, where |s|denotes the length of string s).

All three strings consist only of lowercase English letters.

It is possible that b and c coincide.

Output

Find one of possible strings k, as described in the problem statement. If there are multiple possible answers, print any of them.

Sample test(s)
input
aaa
a
b
output
aaa
input
pozdravstaklenidodiri
niste
dobri
output
nisteaadddiiklooprrvz
input
abbbaaccca
ab
aca
output
ababacabcc
Note

In the third sample, this optimal solutions has three non-overlaping substrings equal to either b or c on positions 1 – 2 (ab), 3 – 4 (ab),5 – 7 (aca). In this sample, there exist many other optimal solutions, one of them would be acaababbcc.


给出a b c三个字符串,在a中可以交换任意两个字母求最多可以构成含有不重复覆盖的b和c的总数最大是多少

先求出最大的b的数,再对numb从0开始 求出对应的numc的值,得出最大的总数

#include <bits/stdc++.h>
using namespace std;
#define Max 100010
string a,b,c;
int al[30],bl[30],cl[30];
int bb,cc;
int main()
{
	cin>>a;
	cin>>b;
	cin>>c;
	int la=a.size();
	int lb=b.size();
	int lc=c.size();
	for(int i=0;i<la;i++)
	{
		al[a[i]-'a'+1]++;
	}
	for(int i=0;i<lb;i++)
	{
		bl[b[i]-'a'+1]++;
	}
	for(int i=0;i<lc;i++)
	{
		cl[c[i]-'a'+1]++;
	}
	int minb=Max,minc=Max;
	for(int i=1;i<=26;i++)
	{
		if(bl[i]!=0)
		{
			minb=min(minb,al[i]/bl[i]);
		}
	}
	for(int i=1;i<=26;i++)
	{
		if(cl[i]!=0)
		{
			minc=min(minc,al[i]/cl[i]);
		}
	}
    int sum=0;
    int y=max(minb,minc);
    for(int i=0;i<=minb;i++)
	{
		int u=Max;
		for(int j=1;j<=26;j++)
		{
			if(cl[j]!=0)
			{
				u=min(u,(al[j]-bl[j]*i)/cl[j]);
			}
		}
		if(u!=Max)
		{
			if(u+i>sum)
			{
				sum=u+i;
				bb=i;
				cc=u;
			}
		}
	}
	for(int i=1;i<=26;i++)
	{
		al[i]-=(bl[i]*bb+cl[i]*cc);
	}
	for(int i=1;i<=bb;i++) cout<<b;
	for(int i=1;i<=cc;i++) cout<<c;
	for(int i=1;i<=26;i++)
	{
		for(int j=1;j<=al[i];j++)
		{
			cout<<(char)(i+'a'-1);
		}
	}
	return 0;
}


C. GukiZ hates Boxes
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Professor GukiZ is concerned about making his way to school, because massive piles of boxes are blocking his way.

In total there are n piles of boxes, arranged in a line, from left to right, i-th pile (1 ≤ i ≤ n) containing ai boxes. Luckily, m students are willing to help GukiZ by removing all the boxes from his way. Students are working simultaneously. At time 0, all students are located left of the first pile. It takes one second for every student to move from this position to the first pile, and after that, every student must start performing sequence of two possible operations, each taking one second to complete. Possible operations are:

  1. If i ≠ n, move from pile i to pile i + 1;
  2. If pile located at the position of student is not empty, remove one box from it.

GukiZ's students aren't smart at all, so they need you to tell them how to remove boxes before professor comes (he is very impatient man, and doesn't want to wait). They ask you to calculate minumum time t in seconds for which they can remove all the boxes from GukiZ's way. Note that students can be positioned in any manner after t seconds, but all the boxes must be removed.

Input

The first line contains two integers n and m (1 ≤ n, m ≤ 105), the number of piles of boxes and the number of GukiZ's students.

The second line contains n integers a1, a2, ... an (0 ≤ ai ≤ 109) where ai represents the number of boxes on i-th pile. It's guaranteed that at least one pile of is non-empty.

Output

In a single line, print one number, minimum time needed to remove all the boxes in seconds.

Sample test(s)
input
2 1
1 1
output
4
input
3 2
1 0 2
output
5
input
4 100
3 4 5 4
output
5
Note

First sample: Student will first move to the first pile (1 second), then remove box from first pile (1 second), then move to the second pile (1 second) and finally remove the box from second pile (1 second).

Second sample: One of optimal solutions is to send one student to remove a box from the first pile and a box from the third pile, and send another student to remove a box from the third pile. Overall, 5 seconds.

Third sample: With a lot of available students, send three of them to remove boxes from the first pile, four of them to remove boxes from the second pile, five of them to remove boxes from the third pile, and four of them to remove boxes from the fourth pile. Process will be over in 5 seconds, when removing the boxes from the last pile is finished.


小孩搬石头,移动和搬都是花费时间1,求最小的时间花费


开始想dp。。然后就没想出来

可以二分+贪心

正难则反,从后往前能就加,如果多加就接着往前接着扫,求出最大的答案

#include <bits/stdc++.h>
using namespace std;
int n,m;
int a[100010],b[100010];
bool check(long long x)
{
	for(int i=1;i<=n;i++) b[i]=a[i];
	int cnt=n;
	long long tmp=0;
	for(int i=1;i<=m;i++)
	{
		while(cnt>0&&b[cnt]==0)
		{
			cnt--;
		}
		if(cnt==0) return true;
		tmp=cnt;
		while(cnt>0&&b[cnt]+tmp<=x)
		{
			tmp+=b[cnt];
			b[cnt]=0;
			cnt--;
		}
		if(cnt==0) return true;
		b[cnt]-=(x-tmp);
	}
	return false;
}
int main()
{
	cin>>n>>m;
	long long sum=n;
	for(int i=1;i<=n;i++)
	{
		cin>>a[i];
		sum+=a[i];
	}
	long long l=0,r=sum,m;
	while(l<r)
	{
		m=(r+l)/2;
		if(check(m)) r=m;
		else l=m+1;
	}
	cout<<l<<endl;
	return 0;
}

剩下两道明天写吧。。



Python网络爬虫与推荐算法新闻推荐平台:网络爬虫:通过Python实现新浪新闻的爬取,可爬取新闻页面上的标题、文本、图片、视频链接(保留排版) 推荐算法:权重衰减+标签推荐+区域推荐+热点推荐.zip项目工程资源经过严格测试可直接运行成功且功能正常的情况才上传,可轻松复刻,拿到资料包后可轻松复现出一样的项目,本人系统开发经验充足(全领域),有任何使用问题欢迎随时与我联系,我会及时为您解惑,提供帮助。 【资源内容】:包含完整源码+工程文件+说明(如有)等。答辩评审平均分达到96分,放心下载使用!可轻松复现,设计报告也可借鉴此项目,该资源内项目代码都经过测试运行成功,功能ok的情况下才上传的。 【提供帮助】:有任何使用问题欢迎随时与我联系,我会及时解答解惑,提供帮助 【附带帮助】:若还需要相关开发工具、学习资料等,我会提供帮助,提供资料,鼓励学习进步 【项目价值】:可用在相关项目设计中,皆可应用在项目、毕业设计、课程设计、期末/期中/大作业、工程实训、大创等学科竞赛比赛、初期项目立项、学习/练手等方面,可借鉴此优质项目实现复刻,设计报告也可借鉴此项目,也可基于此项目来扩展开发出更多功能 下载后请首先打开README文件(如有),项目工程可直接复现复刻,如果基础还行,也可在此程序基础上进行修改,以实现其它功能。供开源学习/技术交流/学习参考,勿用于商业用途。质量优质,放心下载使用。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值